/*
  Smartcard.h - Smartcard library
  Copyright (c) 2012 Fabio Riscica.  All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef Smartcard_h
#define Smartcard_h

#include <Arduino.h>
#include <SPI.h>

class Smartcard
{
  public:
    Smartcard(int slaveSelectPin);
    void PowerOnATRSC(unsigned char *atr);
    void PowerOffSC(void);
    unsigned char ReadByte4442(unsigned char address);
    unsigned char ReadByte4428(unsigned int address);
    void WriteByte4442(unsigned char address, unsigned char data);
    void WriteByte4428(unsigned int address, unsigned char data);
    unsigned char VerifyPSC4442(unsigned char *psc);
    unsigned char VerifyPSC4428(unsigned char *psc);
    void ModifyPSC4442(unsigned char *psc);
    unsigned char IsCardPresent(unsigned char cam);
    unsigned char PowerOnATR(unsigned char cam,unsigned char *atr);
    void ApduCommand(unsigned char cam,unsigned char T, unsigned char *C,unsigned char *D,unsigned char *SW);
    unsigned char Shutdown(unsigned char cam);
    
  private:
    int _slaveSelectPin;
};

#endif

