/*
  Smartcard Library - ResetCard
 
 Demonstrates the use of a SLE4442 sync smartcard.  The Smartcard
 library works with the Arduino Smartcard shield.
 
 This sketch demonstrates the use of the ResetSMC() function and
 display the card ATR (Answer To Reset).
 
 The circuit:
 SmartShield (http://www.elettroinnova.it)
 
 Library originally added 12 Apr 2012
 by Fabio Riscica
  
 This example code is in the public domain.

*/

// include the SPI library:
#include <SPI.h>

//include the Smartcard library
#include <Smartcard.h>

// initialize the library with address of slave select pin
Smartcard smartcard(7);

//convert from hexadecimal to ASCII for display the result 
void HexToAsc(char *c){
	if (((*c&0x0F)>=0)&&((*c&0x0F)<=9))
		*(c+1) = (*c&0x0F)+0x30;
	else
		*(c+1) = (*c&0x0F)+0x37;

	if ((((*c&0xF0)>>4)>=0)&&(((*c&0xF0)>>4)<=9))
		*c = ((*c&0xF0)>>4)+0x30;
	else
		*c = ((*c&0xF0)>>4)+0x37;
}

void setup() {
  // start the serial library:
  Serial.begin(9600);
}

void loop() {
      unsigned char data[4];
      char ascii_data[2];
     
      Serial.print("Wait smartcard insertion... ");
      
      //wait smartcard
      while(!smartcard.IsCardPresent(1)){
        delay(500);  
      }
      Serial.println("done");
      Serial.println();
      Serial.println(">> ResetSC <<");
      Serial.println();
      Serial.print("ATR : ");
      
      //reset smartcard
      smartcard.PowerOnATRSC(data);
      
      ascii_data[0] = data[0];
      HexToAsc(ascii_data);      
      Serial.print(ascii_data[0]);
      Serial.print(ascii_data[1]);
      Serial.print(" ");
      ascii_data[0] = data[1];
      HexToAsc(ascii_data);      
      Serial.print(ascii_data[0]);
      Serial.print(ascii_data[1]);
      Serial.print(" ");
      ascii_data[0] = data[2];
      HexToAsc(ascii_data);      
      Serial.print(ascii_data[0]);
      Serial.print(ascii_data[1]);
      Serial.print(" ");
      ascii_data[0] = data[3];
      HexToAsc(ascii_data);      
      Serial.print(ascii_data[0]);
      Serial.println(ascii_data[1]);
      Serial.println();
      
      smartcard.PowerOffSC();
      
      Serial.print("Wait smartcard extraction...");
      
      //wait smartcard extraction
      while(smartcard.IsCardPresent(1)){
        delay(500);  
      }
      Serial.println("done");
      Serial.println();

  }

